clear all
close all
clc

%simulace AR(2) procesu 
n_simulation=5000;%pocet simulaci
sigma=1;%smerodatna odchylka soku procesu
T=10;%pocet obdobi pro simulaci procesu
minim=inf;
maxim=-inf;

f1=figure;
set(f1,'Name','vysetreni stability');
f2=figure;
set(f2,'Name','stabilni procesy');
f3=figure;
set(f3,'Name','nestabilni procesy');

x_0=[0;0];%pocatecni stav
X=zeros(2,T+1);
X(:,1)=x_0;
cas=1:T+1;
for sim_run=1:n_simulation;
    a=rand(2,1)*10-5;
    

    %stavovy tvar x(t)=Ax(t-1)+u(t)
    A=[a';1 0];
    n_x=length(A);
    u=[randn(1,T)*sigma;zeros(1,T)];
    for horizont=2:T+1
        X(:,horizont)=A*X(:,horizont-1)+u(:,horizont-1);
    end
    
    %vysetreni stability
    eigenvalues=eig(A);
    rho_A=max(abs(eigenvalues));% spektralni polomer  matice A
    if rho_A<1%stabilni system
        set(0,'CurrentFigure',f1)
        plot(a(1),a(2),'bo','MarkerSize',5,'MarkerFaceColor','b');
        hold on
        set(0,'CurrentFigure',f2)
        plot(cas,X(1,:));
        hold on
        maxim=max([maxim abs(X(1,end))]);
    else
        set(0,'CurrentFigure',f1)
        plot(a(1),a(2),'ro','MarkerSize',5,'MarkerFaceColor','r');
        hold on
        set(0,'CurrentFigure',f3)
        plot(cas,X(1,:));
        minim=min([minim abs(X(1,end))]);
        hold on
    end
end